#! /usr/bin/env python2.7

from scapy.all import *
from netfilterqueue import NetfilterQueue
import sys			# for stdin.read
import socket		# for inet_ntoa and inet_aton
import string		# for string.split
import Queue		# Erm, Queue. It's MT safe
import threading

nfq_num = 1
n_threads = 24
hops={}
q = Queue.Queue()

def nfq_cb(packet):
  inpkt = IP(packet.get_payload()) # convert the NF packet to a scapy packet
  packet.drop()	# drop the original NF packet as we have a copy
  q.put(inpkt)	# add packet to queue
  print "Added packet to queue"

def packet_replier():
  while True:
    try:
      pkt=q.get(block=False)
      print "Got packet to %s" % threading.current_thread()
    except Queue.Empty:
	  pass
    else:
      if pkt.ttl in hops:
        hop=hops[pkt.ttl];
        if hop == "*":
          pass
        else:
          inhdr=str(pkt)[:(8 + pkt[IP].ihl * 4)]
          if pkt.ttl < len(hops):
            p=IP(src=hop,dst=pkt.src)/ICMP(type=11,code=0)/inhdr
          else:
            p=IP(src=hop,dst=pkt.src)/ICMP(type=3,code=3)/inhdr
        del(p[ICMP].chksum)
        del(p[IP].chksum)
#        p=p.__class__(str(p))
        send(p)
      else:
       pass
    time.sleep(0.1)

ttl=1
for destip in string.split(sys.stdin.read()):
  try:
# check input is valid IPv4 address
    dip=socket.inet_aton(destip)
    hops[ttl] = socket.inet_ntoa(dip)
    print "%s: %s" % (ttl,hops[ttl])
    ttl+=1
  except socket.error:
    if destip == "*":
      hops[ttl] = "*";
      print "%s: %s" % (ttl,hops[ttl])
      ttl+=1
    else:
      print "%s was not a valid IPv4 address. Exiting.." % destip
      exit()
nfq = NetfilterQueue()
nfq.bind(nfq_num, nfq_cb)

for i in range(n_threads):
  t = threading.Thread(target=packet_replier)
  t.daemon = True
  t.start()
try:
  print "Waiting for packets.."
  nfq.run()
except KeyboardInterrupt:
  pass

